package response

import (
	"gitlab.wodcloud.com/smart-operation/so-operation-api/src/bean/entity"
)

type AlertItem struct {
	entity.Alert `xorm:"extends"`
}

type AlertList struct {
	TotalCount int64       `json:"total_count"`
	List       []AlertItem `json:"list"`
}

type CatIndices struct {
	Health       string `json:"health"`
	Status       string `json:"status"`
	Index        string `json:"index"`
	Uuid         string `json:"uuid"`
	Pri          string `json:"pri"`
	Rep          string `json:"rep"`
	DocsCount    string `json:"docs.count"`
	DocsDeleted  string `json:"docs.deleted"`
	StoreSize    string `json:"store.size"`
	PriStoreSize string `json:"pri.store.size"`
}

type CatIndexCount struct {
	Epoch     string `json:"epoch"`
	Timestamp string `json:"timestamp"`
	Count     string `json:"count"`
}

type OpenSearchSource struct {
	Took     int    `json:"took"`
	TimedOut bool   `json:"timed_out"`
	Shards   Shards `json:"_shards"`
	Hits     Hits   `json:"hits"`
}
type Shards struct {
	Total      int `json:"total"`
	Successful int `json:"successful"`
	Skipped    int `json:"skipped"`
	Failed     int `json:"failed"`
}
type Total struct {
	Value    int    `json:"value"`
	Relation string `json:"relation"`
}

type SubHits struct {
	Index   string    `json:"_index"`
	Type    string    `json:"_type"`
	ID      string    `json:"_id"`
	Score   float64   `json:"_score"`
	Ignored []string  `json:"_ignored"`
	Source  AlertItem `json:"_source"`
}
type Hits struct {
	Total    Total     `json:"total"`
	MaxScore float64   `json:"max_score"`
	Hits     []SubHits `json:"hits"`
}

type AggAlertOverview struct {
	Group struct {
		DocCountErrorUpperBound int `json:"doc_count_error_upper_bound"`
		SumOtherDocCount        int `json:"sum_other_doc_count"`
		Buckets                 []struct {
			Key      int `json:"key"`
			DocCount int `json:"doc_count"`
			Group    struct {
				DocCountErrorUpperBound int `json:"doc_count_error_upper_bound"`
				SumOtherDocCount        int `json:"sum_other_doc_count"`
				Buckets                 []struct {
					Key             string `json:"key"`
					DocCount        int    `json:"doc_count"`
					UnresolvedCount struct {
						DocCount int `json:"doc_count"`
					} `json:"unresolved_count"`
				} `json:"buckets"`
			} `json:"group"`
		} `json:"buckets"`
	} `json:"group"`
}

type AlertDistributionGroup struct {
	Group struct {
		DocCountErrorUpperBound int `json:"doc_count_error_upper_bound"`
		SumOtherDocCount        int `json:"sum_other_doc_count"`
		Buckets                 []struct {
			Key      int `json:"key"`
			DocCount int `json:"doc_count"`
		} `json:"buckets"`
	} `json:"group"`
}

type DateHistogramGroup struct {
	Group struct {
		Buckets []struct {
			KeyAsString string `json:"key_as_string"`
			Key         int64  `json:"key"`
			DocCount    int    `json:"doc_count"`
		} `json:"buckets"`
	} `json:"group"`
}
